aboutsummaryrefslogtreecommitdiffstats
path: root/tests/macros.sh
diff options
context:
space:
mode:
authorOlivier Thauvin <nanardon@mandriva.org>2007-02-22 13:01:24 +0000
committerOlivier Thauvin <nanardon@mandriva.org>2007-02-22 13:01:24 +0000
commit87f50a0d0933b3a61e5f48b7683f92cb4478dfd2 (patch)
treef0b06fdaf572f232edb7071a49f24d9abebb3a56 /tests/macros.sh
parentf3234ef5dcce7d8998bbc77e3ac9f7f87ef0e952 (diff)
downloadrpm-setup-87f50a0d0933b3a61e5f48b7683f92cb4478dfd2.tar
rpm-setup-87f50a0d0933b3a61e5f48b7683f92cb4478dfd2.tar.gz
rpm-setup-87f50a0d0933b3a61e5f48b7683f92cb4478dfd2.tar.bz2
rpm-setup-87f50a0d0933b3a61e5f48b7683f92cb4478dfd2.tar.xz
rpm-setup-87f50a0d0933b3a61e5f48b7683f92cb4478dfd2.zip
- add regression tests
Diffstat (limited to 'tests/macros.sh')
-rwxr-xr-xtests/macros.sh28
1 files changed, 28 insertions, 0 deletions
diff --git a/tests/macros.sh b/tests/macros.sh
new file mode 100755
index 0000000..519e7b4
--- /dev/null
+++ b/tests/macros.sh
@@ -0,0 +1,28 @@
+#!/bin/sh
+
+# $Id$
+
+RPMEVAL=./rpmeval
+
+err=0
+
+mcheck() {
+ macro=$1
+ is=$2
+ echo -n "${macro}... "
+ res=`$RPMEVAL macros ${macro}`
+ if [ "X${res}" != "X${is}" ]; then
+ echo "give ${res} not ${is}"
+ err=$[ $err + 1]
+ else
+ echo "OK"
+ fi
+}
+
+mcheck %_var /var
+mcheck %_localstatedir /var/lib
+mcheck %_bindir /usr/bin
+mcheck %_sbindir /usr/sbin
+mcheck %_prefix /usr
+
+exit $err
href='#n93'>93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159
package interactive::http; # $Id$

use diagnostics;
use strict;
use vars qw(@ISA);

@ISA = qw(interactive);

use CGI;
use interactive;
use common;
use log;

my $script_name = $ENV{INTERACTIVE_HTTP};
my $no_header;
my $uid;
my $pipe_r = "/tmp/interactive_http_r";
my $pipe_w = "/tmp/interactive_http_w";

sub open_stdout {
    open STDOUT, ">$pipe_w" or die;
    $| = 1;
    print CGI::header();
    $no_header = 1;    
}

# cont_stdout must be called after open_stdout and before the first print
sub cont_stdout {
    my ($title) = @_;
    print CGI::start_html(-title => $title) if $no_header;
    $no_header = 0;
}

sub new_uid {
    my ($s, $ms) = gettimeofday();
    $s * 256 + $ms % 256;
}

sub new() {
    open_stdout();
    bless {}, $_[0];
}

sub end() { 
    -e $pipe_r or return; # don't run this twice
    my $q = CGI->new;
    cont_stdout("Exit");
    print "It's done, thanks for playing", $q->end_html;
    close STDOUT;
    unlink $pipe_r, $pipe_w;
}
sub exit() { end; exit($_[1]) }
END { end() }

sub ask_fromW {
    my ($o, $common, $l, $l2) = @_;

  redisplay:
    my $uid = new_uid();
    my $q = CGI->new;
    $q->param(state => 'next_step');
    $q->param(uid => $uid);
    cont_stdout($common->{title});

#    print $q->img({ -src => "/icons/$o->{icon}" }) if $o->{icon};
    print @{$common->{messages}};
    print $q->start_form(-name => 'form', -action => $script_name, -method => 'post');

    print "<table>\n";

    map_index {
	my $e = $_;

	print "<tr><td>$e->{label}</td><td>\n";

	$e->{type} = 'list' if $e->{type} =~ /(icon|tree)list/;

	#- combo doesn't exist, fallback to a sensible default
	$e->{type} = $e->{not_edit} ? 'list' : 'entry' if $e->{type} eq 'combo';

	if ($e->{type} eq 'bool') {
	    print $q->checkbox(-name => "w$::i", -checked => ${$e->{val}} && 'on', -label => $e->{text} || " ");
	} elsif ($e->{type} eq 'button') {
	    print "nobuttonyet";
	} elsif ($e->{type} =~ /list/) {
	    my %t; 
	    $t{$_} = may_apply($e->{format}, $_) foreach @{$e->{list}};

	    print $q->scrolling_list(-name => "w$::i",
				     -values => $e->{list},
				     -default => [ ${$e->{val}} ],
				     -size => 5, -multiple => '', -labels => \%t);
	} else {
	    print $e->{hidden} ?
	      $q->password_field(-name => "w$::i", -default => ${$e->{val}}) :
	      $q->textfield     (-name => "w$::i", -default => ${$e->{val}});
	}

	print "</td></tr>\n";
    } @$l;

    print "</table>\n";
    print $q->p();
    print $q->submit(-name => 'ok_submit', -value => $common->{ok} || _("Ok"));
    print $q->submit(-name => 'cancel_submit', -value => $common->{cancel} || _("Cancel")) if $common->{cancel} || !exists $common->{ok};
    print $q->hidden('state'), $q->hidden('uid');
    print $q->end_form, $q->end_html;

    close STDOUT; # page terminated

    while (1) {	
	local *F;
	open F, "<$pipe_r" or die;
	$q = CGI->new(\*F);
	$q->param('force_exit_dead_prog') and $o->exit;
	last if $q->param('uid') == $uid;

	open_stdout(); # re-open for writing
	cont_stdout(_("Error"));
	print $q->h1(_("Error")), $q->p("Sorry, you can't go back");
	goto redisplay;
    }
    map_index {
	my $e = $_;
	my $v = $q->param("w$::i");
	if ($e->{type} eq 'bool') {
	    $v = $v eq 'on';
	}
	${$e->{val}} = $v;
    } @$l;

    open_stdout(); # re-open for writing
    $q->param('ok_submit');
}

sub p {
    print "\n" . CGI::br($_) foreach @_;
}

sub wait_messageW {
    my ($o, $title, $messages) = @_;
    cont_stdout();
    print "\n" . CGI::p();
    p(@$messages);
}

sub wait_message_nextW {
    my ($o, $messages, $w) = @_;
    p(@$messages);
}
sub wait_message_endW {
    my ($o, $w) = @_;
    p(_("Done"));
    print "\n" . CGI::p();
}